<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: block_template.xsl,v 1.5 2010-10-14 17:57:14 hz0wyg Exp $ -->

<xsl:stylesheet version='1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:xmi='http://www.omg.org/XMI'
	xmlns:sysML='http://www.topcased.org/1.0/sysML'
	xmlns:ConfigurationProfile='http:///schemas/ConfigurationProfile/_DzOpgNMHEd-zD4zFaippQA/5'
	exclude-result-prefixes='xsl xmi sysML ConfigurationProfile'>
	
	<xsl:output method="text"/>
<!--	<xsl:include href="step_template.xsl"/>   Included by caller -->
	
	
	<xsl:template name="block">
		<xsl:variable name="name" select="@name"/>
		<xsl:variable name="apos">'</xsl:variable>
		<xsl:variable name="version" select="./ownedAttribute[@name='version']/defaultValue/@value"/>
		<xsl:variable name="version_offset" select="10"/>
		<xsl:variable name="view_definition_offset" select="20"/>		
		<xsl:variable name="usage_offset" select="30"/>
		<xsl:variable name="system_offset" select="-20"/>		
		<xsl:variable name="system_version_offset" select="-18"/>		
		<xsl:variable name="system_view_offset" select="-16"/>		
		<xsl:variable name="system_breakdown_offset" select="-14"/>		
		<xsl:variable name="system_breakdown_version_offset" select="-12"/>		
		<xsl:variable name="breakdown_of_offset" select="-10"/>		
		<xsl:variable name="breakdown_context_offset" select="-8"/>		
		<xsl:variable name="xmi_id">
			<xsl:call-template name="step-xmi-id">
				<xsl:with-param name="xmi_id" select="@xmi:id"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="parent_xmi_id">
			<xsl:call-template name="step-xmi-id">
				<xsl:with-param name="xmi_id" select="../@xmi:id"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="parent_type" select="../@xmi:type"/>
		<xsl:variable name="system_block" select="//ConfigurationProfile:system/@base_Block"/>
			
<!--

#920=SYSTEM('HSUV','HSUVSystem','Hybrid Sport Utility Vehicle System');
#930=SYSTEM_VERSION('HSUV-1','HSUVSystem version',#920);
#940=SYSTEM_VIEW_DEFINITION('HSUV-1','HSUVSystem view definition','',#40,(),#930);
#950=SYSTEM_BREAKDOWN('HSUV','HybridSUV Breakdown','Hybrid Sport Utility Vehicle System breakdown');
#960=SYSTEM_BREAKDOWN_VERSION('HSUV-1-Breakdown','HybridSUV breakdown version',#950);
#970=BREAKDOWN_OF('HSUV-Breakdown-of','HSUV-1-Breakdown-of','Breakdown of HSUVSystem',#960,#940);
#980=SYSTEM_ELEMENT('HSUV-Element','HSUVSystem','Hybrid Sport Utility Vehicle System element');
#990=SYSTEM_ELEMENT_VERSION('1','HSUVSystem element version',#980);
#1000=SYSTEM_ELEMENT_DEFINITION('HSUV-1','HSUVSystem element definition','',#40,(),#990);
#1010=SYSTEM_ELEMENT('p','PowerSubsystem','PowerSubsystem');
#1020=SYSTEM_ELEMENT_VERSION('1','PowerSubsystem version',#1010);
#1030=SYSTEM_ELEMENT_DEFINITION('p-1','PowerSubsystem element definition','',#40,(),#1020);
#1040=SYSTEM_ELEMENT_USAGE('HSUV->p','','PowerSubsystem of HSUV',#1000,#1030);
#1330=SYSTEM_BREAKDOWN_CONTEXT('HSUV-Context','HSUV-Context','HSUV System Breakdown Context to top System Element',#960,#1000);

-->
		<xsl:if test="@xmi:id=$system_block">
			<xsl:value-of select="concat('#',$xmi_id+$system_offset,'=SYSTEM(',$apos,$xmi_id,$apos,',',$apos,$name,$apos,',',$apos,$name,' System',$apos,');')"/>
			<xsl:text>
			</xsl:text>
			<xsl:value-of select="concat('#',$xmi_id+$system_version_offset,'=SYSTEM_VERSION(',$apos,$version,$apos,',',$apos,$name,' System Element Version',$apos,',','#',$xmi_id,');')"/>
			<xsl:text>
			</xsl:text>
			<xsl:value-of select="concat(
									'#',$xmi_id+$system_view_offset,'=SYSTEM_VIEW_DEFINITION(',
										$apos,$version,$apos,',',
										$apos,$name,' System View Definition',$apos,',',
										$apos,$apos,',',
										'#1',',',
										'(),',
										'#',$xmi_id+$system_version_offset,
									');'
								)"/>
			<xsl:text>
			</xsl:text>
			<xsl:value-of select="concat('#',$xmi_id+$system_breakdown_offset,'=SYSTEM_BREAKDOWN(',$apos,$xmi_id,$apos,',',$apos,$name,$apos,',',$apos,$name,' System Breakdown',$apos,');')"/>
			<xsl:text>
			</xsl:text>
			<xsl:value-of select="concat('#',$xmi_id+$system_breakdown_version_offset,'=SYSTEM_BREAKDOWN_VERSION(',$apos,$version,$apos,',',$apos,$name,' System Breakdown Version',$apos,',','#',$xmi_id+$system_breakdown_offset,');')"/>
			<xsl:text>
			</xsl:text>
			<xsl:value-of select="concat(
									'#',$xmi_id+$breakdown_of_offset,'=BREAKDOWN_OF(',
										$apos,$version,$apos,',',
										$apos,$name,$apos,',',
										$apos,$name,' Breakdown',$apos,',',
										'#',$xmi_id+$system_breakdown_version_offset,',',
										'#',$xmi_id+$system_view_offset,
									');'
								)"/>
			<xsl:text>
			</xsl:text>
			<xsl:value-of select="concat(
									'#',$xmi_id+$breakdown_context_offset,'=SYSTEM_BREAKDOWN_CONTEXT(',
										$apos,$version,$apos,',',
										$apos,$name,$apos,',',
										$apos,$name,' Breakdown Context',$apos,',',
										'#',$xmi_id+$system_breakdown_version_offset,',',
										'#',$xmi_id+$view_definition_offset,
									');'
								)"/>
			<xsl:text>
			</xsl:text>
		</xsl:if>
		<xsl:value-of select="concat('#',$xmi_id,'=SYSTEM_ELEMENT(',$apos,$xmi_id,$apos,',',$apos,$name,$apos,',',$apos,$name,' System Element',$apos,');')"/>
		<xsl:text>
		</xsl:text>
		<xsl:value-of select="concat('#',$xmi_id+$version_offset,'=SYSTEM_ELEMENT_VERSION(',$apos,$version,$apos,',',$apos,$name,' System Element Version',$apos,',','#',$xmi_id,');')"/>
		<xsl:text>
		</xsl:text>
		<xsl:value-of select="concat(
								'#',$xmi_id+$view_definition_offset,'=SYSTEM_ELEMENT_DEFINITION(',
									$apos,$version,$apos,',',
									$apos,$name,' System Element Definition',$apos,',',
									$apos,$apos,',',
									'#1',',',
									'(),',
									'#',$xmi_id+$version_offset,
								');'
							)"/>
		<xsl:text>
		</xsl:text>
		<xsl:if test="not(@xmi:id=$system_block)">
			<xsl:value-of select="concat(
								'#',$xmi_id+$usage_offset,'=SYSTEM_ELEMENT_USAGE(',
									$apos,$version,$apos,',',
									$apos,$apos,',',
									$apos,$name,' System Element Usage',$apos,',',
									'#',$parent_xmi_id+$view_definition_offset,',',
									'#',$xmi_id+$view_definition_offset,',',
									$apos,$name,$apos,
								');'
							)"/>
			<xsl:text>
			</xsl:text>
		</xsl:if>

		<xsl:call-template name="block-constituent-rows"></xsl:call-template>
	</xsl:template>
	
	<xsl:template name="block-constituent-rows">
		<xsl:for-each select="./nestedClassifier[@xmi:type='sysML:Block']">
			<xsl:call-template name="block"/>
		</xsl:for-each>
	</xsl:template>
	
</xsl:stylesheet>
