<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: req_extract.xsl,v 1.5 2010-10-01 19:53:36 hz0wyg Exp $ -->

<xsl:stylesheet version='1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:xmi='http://www.omg.org/XMI'
	xmlns:sysML='http://www.topcased.org/1.0/sysML'
	xmlns:uml='http://www.eclipse.org/uml2/2.1.0/UML'
	exclude-result-prefixes='xsl xmi sysML uml'>
	
	<xsl:param name="year"/>
	<xsl:param name="month"/>
	<xsl:param name="day"/>
	<xsl:param name="hour"/>
	<xsl:param name="minute"/>
	<xsl:param name="second"/>
	<xsl:param name="tzoffset_direction"/>
	<xsl:param name="tzoffset_hours"/>
	<xsl:param name="filename"/>
	<xsl:param name="author-firstname"/>
	<xsl:param name="author-lastname"/>
	<xsl:param name="organization"/>
	<xsl:output method="text"/>
	<xsl:key name="ids" match="/" use="@xmi:id"/>
	<xsl:include href="step_template.xsl"/>
	<xsl:include href="requirement_template.xsl"/>
	<xsl:include href="person_org_assignment_template.xsl"/>
	<xsl:include href="applied_activity_assignment_template.xsl"/>
	
	<xsl:template match="/">
		<xsl:call-template name="step-header">
			<xsl:with-param name="year"><xsl:value-of select="$year"/></xsl:with-param>
			<xsl:with-param name="month"><xsl:value-of select="$month"/></xsl:with-param>
			<xsl:with-param name="day"><xsl:value-of select="$day"/></xsl:with-param>
			<xsl:with-param name="hour"><xsl:value-of select="$hour"/></xsl:with-param>
			<xsl:with-param name="minute"><xsl:value-of select="$minute"/></xsl:with-param>
			<xsl:with-param name="second"><xsl:value-of select="$second"/></xsl:with-param>
			<xsl:with-param name="tzoffset_direction"><xsl:value-of select="$tzoffset_direction"/></xsl:with-param>
			<xsl:with-param name="tzoffset_hours"><xsl:value-of select="$tzoffset_hours"/></xsl:with-param>
			<xsl:with-param name="filename"><xsl:value-of select="$filename"/></xsl:with-param>
			<xsl:with-param name="author-firstname"><xsl:value-of select="$author-firstname"/></xsl:with-param>
			<xsl:with-param name="author-lastname"><xsl:value-of select="$author-lastname"/></xsl:with-param>
			<xsl:with-param name="organization"><xsl:value-of select="$organization"/></xsl:with-param>
		</xsl:call-template>
 		<xsl:call-template name="requirement-centric"/>
		<xsl:call-template name="step-footer"></xsl:call-template>
	</xsl:template>
	
	<xsl:template name="requirement-centric">
		<xsl:for-each select="//packagedElement[@xmi:type='sysML:Requirement']">
			<xsl:sort data-type="number" select="@id"/>
			<xsl:call-template name="requirement"/>
		</xsl:for-each>
		<xsl:call-template name="person_org_assignment"></xsl:call-template>
		<xsl:call-template name="applied_activity_assignment"></xsl:call-template>
	</xsl:template>
	
	<xsl:template name="gencomment">
		General Comments
		<xsl:for-each select="//ownedComment[@xmi:type='uml:Comment']/body[not(starts-with(.,'Model: $Id:'))]">
			<xsl:if test="count(//ownedComment[@xmi:type='uml:Comment']/annotatedElement)=0 and string-length(../@annotatedElement)=0">
				<xsl:value-of select="../body"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="extrefcomment">
		External Reference Comments
		Refers to
		Text
		<xsl:for-each select="//ownedComment[@xmi:type='uml:Comment']/annotatedElement[@xmi:type='sysML:PackageSYSML']">
			<xsl:value-of select="substring-before(@href,'.')"/>
			<xsl:value-of select="../body"/>
		</xsl:for-each>
	</xsl:template>
	
</xsl:stylesheet>
